<!DOCTYPE html>
<html lang="en"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:th="http://www.thymeleaf.org"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout}">
<head>
    <meta charset="UTF-8">
    <title>Account</title>
</head>
<body>
<main layout:fragment="main" class="container-xxl bd-gutter mt-3 my-md-4 bd-layout">
    <!--        <div th:insert="~{/sidebar/sidebar_setting :: sidebar_setting}" th:remove="tag">-->
    <!--            sidebar-->
    <!--        </div>-->
    <div th:include="sidebar/sidebar_setting::sidebar_setting" th:remove="tag">
        sidebar
    </div>
    <main class="bd-main-xxl">
        <div class="row">
            <div class="col-md-12">
                <div class="card shadow-sm">
                    <div class="card-header">
                        <h5>List Account</h5>
                    </div>
                    <div class="card-body">
                        <div class="row mb-3">
                            <div class="col-md-12 text-end mb-2">
                                <button class="btn btn-success btn-sm" data-bs-toggle="modal" data-bs-target="#addAccount">
                                    <i class="fa fa-plus-circle"></i> &nbsp; Account
                                </button>
                                <a th:href="@{/download/account}" class="btn btn-info btn-sm text-white"><i class="fa fa-download"></i> Download</a>
                                <div class="modal fade" id="addAccount" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <form th:action="@{/account/save}" method="post">
                                                <div class="modal-header">
                                                    <h5 class="modal-title" id="exampleModalLabel">Add Account</h5>
                                                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                                                </div>
                                                <div class="modal-body text-start">
                                                    <div class="form-group mb-2">
                                                        <label>Subclassification</label>
                                                        <select name="subclassification" id="select" class="form-control" style="width: 100%;" required
                                                                onchange="getCode(this)">
                                                            <option value=""></option>
                                                            <option th:each="data, row:${classification}"
                                                                    th:value="${data.id}"
                                                                    th:text="${data.name + ' ('+data.classification.name + ')'}"></option>
                                                        </select>
                                                    </div>
                                                    <div class="form-group mb-2">
                                                        <label for="code">Code</label>
                                                        <input type="text" id="code" onkeyup="checkCode(this)" onchange="checkCode(this)" name="code" class="form-control" required>
                                                        <span style="display: none; color: red" id="validateCode">* the code has already been used</span>
                                                    </div>
                                                    <div class="form-group mb-2">
                                                        <label for="name">Name</label>
                                                        <input type="text" id="name" minlength="3" placeholder="ex : cash" name="name" class="form-control" required>
                                                    </div>
                                                    <div class="form-group mb-2">
                                                        <label>Account Type</label>
                                                        <select name="accountType" class="form-select">
                                                            <option value="" selected>-- Select --</option>
                                                            <option th:each="accountType : ${T(id.ac.tazkia.accounting.entity.AccountType).values()}"
                                                                    th:value="${accountType}" th:text="${accountType}"
                                                            >AKTIVA</option>
                                                        </select>
                                                    </div>
                                                    <div class="form-group mb-2">
                                                        <label>Balance Type</label>
                                                        <select name="nominalBalance" class="form-select">
                                                            <option value="" selected>-- Select --</option>
                                                            <option value="DEBET">DEBET</option>
                                                            <option value="CREDIT">CREDIT</option>
                                                        </select>
                                                    </div>
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                                                    <button type="submit" class="btn btn-primary" id="btnSubmit">Save</button>
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row mb-3">
                            <div class="col-md-4"></div>
                            <div class="col-md-4"></div>
                            <div class="col-md-4">
                                <form method="get">
                                    <input type="text" class="form-control" placeholder="search" name="search">
                                </form>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <div class="alert alert-success alert-dismissible fade show" role="alert" th:if="${success != null}">
                                    <strong th:text="${success}"></strong>
                                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                </div>
                                <div class="alert alert-danger alert-dismissible fade show" role="alert" th:if="${error != null}">
                                    <strong th:text="${error}"></strong>
                                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                </div>
                            </div>
                        </div>
                        <div class="table-responsive">
                            <table class="table table-striped table-bordered">
                                <thead class="table-dark" style="--bs-table-bg: #0a3e8a">
                                <tr>
                                    <th style="width: 5%;">No.</th>
                                    <th style="width: 10%;">Code</th>
                                    <th style="width: 25%;">Name</th>
                                    <th style="width: 20%;">Subclassification</th>
                                    <th style="width: 10%;">Classification</th>
                                    <th style="width: 5%;">Account Type</th>
                                    <th style="width: 5%;">Balance Type</th>
                                    <th style="width: 5%;"></th>
                                    <th style="width: 5%;"></th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr th:each="data, row:${list}">
                                    <td th:text="${(row.index + 1)}"></td>
                                    <td th:text="${data.code}"></td>
                                    <td th:text="${data.name}"></td>
                                    <td>
                                        <span th:if="${data.subclassification != null}" th:text="${data.subclassification.name}"></span>
                                    </td>
                                    <td>
                                        <span th:if="${data.subclassification != null}" th:text="${data.subclassification.classification.name}"></span>
                                    </td>
                                    <td th:text="${data.accountType}"></td>
                                    <td th:text="${data.nominalBalance}"></td>
                                    <td>
                                        <a th:href="@{/account/edit(account = ${data.id})}" class="btn btn-warning btn-sm">Edit</a>
                                    </td>
                                    <!--                                    <td th:text="${'Rp. '+ #numbers.formatDecimal(data.amount,  0, 'POINT', 2, 'COMMA')}"></td>-->
                                    <td>
                                        <a th:href="@{/account/delete(id = ${data.id})}"
                                           onclick="return confirm('Apakah Anda yakin ingin menghapus data ini ?');"
                                           class="btn btn-danger btn-sm">Delete</a>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                            <nav aria-label="Page navigation example">
                                <ul class="pagination justify-content-center" sd:pagination="full">
                                    <li class="page-item disabled">
                                        <a class="page-link" href="#" tabindex="-1">Previous</a>
                                    </li>
                                    <li class="page-item"><a class="page-link" href="#">1</a></li>
                                    <li class="page-item"><a class="page-link" href="#">2</a></li>
                                    <li class="page-item"><a class="page-link" href="#">3</a></li>
                                    <li class="page-item">
                                        <a class="page-link" href="#">Next</a>
                                    </li>
                                </ul>
                            </nav>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
</main>
<div layout:fragment="footer" class="script">
    <script>
        $('#select').select2({
            theme: 'bootstrap-5',
            placeholder: '- Select Subclassification -'
        });

        var delay = (function () {
            var timer = 0;
            return function (callback, ms) {
                clearTimeout(timer);
                timer = setTimeout(callback, ms);
            };
        })();

        function checkCode(arg) {
            var value = arg.value;

            $(document).keyup(function (e) {
                delay(function () {
                    var url = "/api/account/check?code="+value;
                    $.getJSON(url, function (data) {
                        if (data.code == 'FORBIDDEN'){
                            document.getElementById("validateCode").style.display = "block";
                            document.getElementById("btnSubmit").disabled = true;
                            console.log(data.message)
                        }else {
                            document.getElementById("validateCode").style.display = "none";
                            document.getElementById("btnSubmit").disabled = false;
                            console.log(data.message)
                        }

                    })

                }, 800);

            });
        }

        function getCode(selectElement) {
            var selectedId = selectElement.value;
            var url = "/api/code-account?id=" + selectedId;

            $.getJSON(url, function (data) {
                console.log("API Response:", data);
                $("input[name='code']").val(data.data);
            });
        }

    </script>
</div>

</body>

</html>